(define (domain blocks)
 (:predicates (clear_a) (ontable_a) (handempty) (holding_a) (clear_c) (ontable_c) (holding_c) (clear_d) (ontable_d) (holding_d) (clear_b) (ontable_b) (holding_b) (on_a_a) (on_a_c) (on_a_d) (on_a_b) (on_c_a) (on_c_c) (on_c_d) (on_c_b) (on_d_a) (on_d_c) (on_d_d) (on_d_b) (on_b_a) (on_b_c) (on_b_d) (on_b_b))
 (:action pick-up_a
  :precondition (and (clear_a) (ontable_a) (handempty))
  :effect (and (holding_a) (not (clear_a)) (not (ontable_a)) (not (handempty))))
 (:action pick-up_c
  :precondition (and (handempty) (clear_c) (ontable_c))
  :effect (and (holding_c) (not (handempty)) (not (clear_c)) (not (ontable_c))))
 (:action pick-up_d
  :precondition (and (handempty) (clear_d) (ontable_d))
  :effect (and (holding_d) (not (handempty)) (not (clear_d)) (not (ontable_d))))
 (:action pick-up_b
  :precondition (and (handempty) (clear_b) (ontable_b))
  :effect (and (holding_b) (not (handempty)) (not (clear_b)) (not (ontable_b))))
 (:action put-down_a
  :precondition (holding_a)
  :effect (and (clear_a) (ontable_a) (handempty) (not (holding_a))))
 (:action put-down_c
  :precondition (holding_c)
  :effect (and (handempty) (clear_c) (ontable_c) (not (holding_c))))
 (:action put-down_d
  :precondition (holding_d)
  :effect (and (handempty) (clear_d) (ontable_d) (not (holding_d))))
 (:action put-down_b
  :precondition (holding_b)
  :effect (and (handempty) (clear_b) (ontable_b) (not (holding_b))))
 (:action stack_a_a
  :precondition (and (clear_a) (holding_a))
  :effect (and (clear_a) (handempty) (on_a_a) (not (clear_a)) (not (holding_a))))
 (:action stack_a_c
  :precondition (and (holding_a) (clear_c))
  :effect (and (clear_a) (handempty) (on_a_c) (not (holding_a)) (not (clear_c))))
 (:action stack_a_d
  :precondition (and (holding_a) (clear_d))
  :effect (and (clear_a) (handempty) (on_a_d) (not (holding_a)) (not (clear_d))))
 (:action stack_a_b
  :precondition (and (holding_a) (clear_b))
  :effect (and (clear_a) (handempty) (on_a_b) (not (holding_a)) (not (clear_b))))
 (:action stack_c_a
  :precondition (and (clear_a) (holding_c))
  :effect (and (handempty) (clear_c) (on_c_a) (not (clear_a)) (not (holding_c))))
 (:action stack_c_c
  :precondition (and (clear_c) (holding_c))
  :effect (and (handempty) (clear_c) (on_c_c) (not (clear_c)) (not (holding_c))))
 (:action stack_c_d
  :precondition (and (holding_c) (clear_d))
  :effect (and (handempty) (clear_c) (on_c_d) (not (holding_c)) (not (clear_d))))
 (:action stack_c_b
  :precondition (and (holding_c) (clear_b))
  :effect (and (handempty) (clear_c) (on_c_b) (not (holding_c)) (not (clear_b))))
 (:action stack_d_a
  :precondition (and (clear_a) (holding_d))
  :effect (and (handempty) (clear_d) (on_d_a) (not (clear_a)) (not (holding_d))))
 (:action stack_d_c
  :precondition (and (clear_c) (holding_d))
  :effect (and (handempty) (clear_d) (on_d_c) (not (clear_c)) (not (holding_d))))
 (:action stack_d_d
  :precondition (and (clear_d) (holding_d))
  :effect (and (handempty) (clear_d) (on_d_d) (not (clear_d)) (not (holding_d))))
 (:action stack_d_b
  :precondition (and (holding_d) (clear_b))
  :effect (and (handempty) (clear_d) (on_d_b) (not (holding_d)) (not (clear_b))))
 (:action stack_b_a
  :precondition (and (clear_a) (holding_b))
  :effect (and (handempty) (clear_b) (on_b_a) (not (clear_a)) (not (holding_b))))
 (:action stack_b_c
  :precondition (and (clear_c) (holding_b))
  :effect (and (handempty) (clear_b) (on_b_c) (not (clear_c)) (not (holding_b))))
 (:action stack_b_d
  :precondition (and (clear_d) (holding_b))
  :effect (and (handempty) (clear_b) (on_b_d) (not (clear_d)) (not (holding_b))))
 (:action stack_b_b
  :precondition (and (clear_b) (holding_b))
  :effect (and (handempty) (clear_b) (on_b_b) (not (clear_b)) (not (holding_b))))
 (:action unstack_a_a
  :precondition (and (clear_a) (handempty) (on_a_a))
  :effect (and (clear_a) (holding_a) (not (clear_a)) (not (handempty)) (not (on_a_a))))
 (:action unstack_a_c
  :precondition (and (clear_a) (handempty) (on_a_c))
  :effect (and (holding_a) (clear_c) (not (clear_a)) (not (handempty)) (not (on_a_c))))
 (:action unstack_a_d
  :precondition (and (clear_a) (handempty) (on_a_d))
  :effect (and (holding_a) (clear_d) (not (clear_a)) (not (handempty)) (not (on_a_d))))
 (:action unstack_a_b
  :precondition (and (clear_a) (handempty) (on_a_b))
  :effect (and (holding_a) (clear_b) (not (clear_a)) (not (handempty)) (not (on_a_b))))
 (:action unstack_c_a
  :precondition (and (handempty) (clear_c) (on_c_a))
  :effect (and (clear_a) (holding_c) (not (handempty)) (not (clear_c)) (not (on_c_a))))
 (:action unstack_c_c
  :precondition (and (handempty) (clear_c) (on_c_c))
  :effect (and (clear_c) (holding_c) (not (handempty)) (not (clear_c)) (not (on_c_c))))
 (:action unstack_c_d
  :precondition (and (handempty) (clear_c) (on_c_d))
  :effect (and (holding_c) (clear_d) (not (handempty)) (not (clear_c)) (not (on_c_d))))
 (:action unstack_c_b
  :precondition (and (handempty) (clear_c) (on_c_b))
  :effect (and (holding_c) (clear_b) (not (handempty)) (not (clear_c)) (not (on_c_b))))
 (:action unstack_d_a
  :precondition (and (handempty) (clear_d) (on_d_a))
  :effect (and (clear_a) (holding_d) (not (handempty)) (not (clear_d)) (not (on_d_a))))
 (:action unstack_d_c
  :precondition (and (handempty) (clear_d) (on_d_c))
  :effect (and (clear_c) (holding_d) (not (handempty)) (not (clear_d)) (not (on_d_c))))
 (:action unstack_d_d
  :precondition (and (handempty) (clear_d) (on_d_d))
  :effect (and (clear_d) (holding_d) (not (handempty)) (not (clear_d)) (not (on_d_d))))
 (:action unstack_d_b
  :precondition (and (handempty) (clear_d) (on_d_b))
  :effect (and (holding_d) (clear_b) (not (handempty)) (not (clear_d)) (not (on_d_b))))
 (:action unstack_b_a
  :precondition (and (handempty) (clear_b) (on_b_a))
  :effect (and (clear_a) (holding_b) (not (handempty)) (not (clear_b)) (not (on_b_a))))
 (:action unstack_b_c
  :precondition (and (handempty) (clear_b) (on_b_c))
  :effect (and (clear_c) (holding_b) (not (handempty)) (not (clear_b)) (not (on_b_c))))
 (:action unstack_b_d
  :precondition (and (handempty) (clear_b) (on_b_d))
  :effect (and (clear_d) (holding_b) (not (handempty)) (not (clear_b)) (not (on_b_d))))
 (:action unstack_b_b
  :precondition (and (handempty) (clear_b) (on_b_b))
  :effect (and (clear_b) (holding_b) (not (handempty)) (not (clear_b)) (not (on_b_b))))
)
(define (problem blocks-4-2)
 (:domain blocks)
 (:init (clear_a) (ontable_a) (handempty) (clear_c) (clear_d) (ontable_d) (ontable_b) (on_c_b))
 (:goal (and (on_a_b) (on_c_d) (on_b_c)))
)
